// iPaq 3D engine  -  Janurary 2001  -  The Phantom
// Minimal 3D engine for Handhelds
// ------------------------------------------------

#ifndef RASTERIZE_H
#define RASTERIZE_H

// #define INTERLACE

#include "engine.h"

class ARasterizer
{
public:
	ARasterizer();
	~ARasterizer();
	void nextframe( void );
	void update( PIXEL* a_Dest );
	void draw( APolygon* a_Poly );
	void drawtri( APolygon* a_Poly );
	void drawfast( APolygon* a_Poly, PIXEL a_Color );
	void drawtext( APolygon* a_Poly );
	void setbuffer( PIXEL* a_Dest ) { m_Dest = a_Dest; }
	PIXEL* getbuffer( void ) { return m_Dest; }
	PIXEL* getzbuffer( void ) { return m_ZBuffer; }
private:
	PIXEL* m_Dest;
	PIXEL* m_ZBuffer;
	int m_Left[240], m_Right[240];
	int m_ULeft[240], m_URight[240];
	int m_VLeft[240], m_VRight[240];
	int m_ZLeft[240], m_ZRight[240];
	int m_Lines;
};

#endif

// ------------------------------------------------
// EOF